var Dfe11000_LancamentoEntrada_Service = function(localStorageEngine, Dfe11000_LancamentoEntrada_Repositories, General) {

    this.excluirNotaEntrada = function (lancamentoRow) {
        var filial = lancamentoRow.CDFILIAL;
        var sequencial = lancamentoRow.NRLANCTONF;
        return Dfe11000_LancamentoEntrada_Repositories.excluirNotaEntrada(filial, sequencial);
    };
    
    this.excluiVencimento = function(vencimentoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.excluiVencimento(vencimentoRow);
    };
    
    this.salvaVencimento = function(vencimentoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.salvaVencimento(vencimentoRow);
    };
    
    this.isAFTipoOper = function(tipooper, filial) {
        var filter = [
            {
                "name": "CDTIPOOPER",
                "operator": "=",
                "value": tipooper
            },
            {
                "name": "IDENTRSAIDOP",
                "operator": "=",
                "value": 'E'
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        return General.callRestEngine("df#/crud/parambloqnfafil", "FilterData", filter).then(success =>{
            if(success.dataset.parambloqnfafil[0]){
                var parameter = success.dataset.parambloqnfafil[0];
                    if(parameter.IDEXIGEAF == 'S')
                        return true;
                    else
                        return false;
            }
            return false;
        });
    };

    this.excluiVencimento = function(vencimentoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.excluiVencimento(vencimentoRow);
    };

    this.excluirNota = function(consultaLancamentoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.excluirNota(consultaLancamentoRow.CDFILIAL, consultaLancamentoRow.NRLANCTONF);
    };

    this.calculaImpostoItemProduto = function(cabecalhoRow, lancamentoItemRow) {
        return Dfe11000_LancamentoEntrada_Repositories.calculaImpostoItemProduto(cabecalhoRow, lancamentoItemRow);
    };
    
    this.validaParamProduto = function(cdfilial, cdarvprod) {
        var row = {
            "CDFILIAL" : cdfilial,
            "CDARVPROD": cdarvprod
        };
        return Dfe11000_LancamentoEntrada_Repositories.validaParamProduto(row);
    };

    this.realizaImportacaoItensNotaOrigem = function(cabecalhoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.realizaImportacaoItensNotaOrigem(cabecalhoRow);
    };
    
    this.validaAF = function(row){
        return Dfe11000_LancamentoEntrada_Repositories.validaAF(row);
    };

    this.realizaImportacaoAf = function(cabecalhoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.realizaImportacaoAf(cabecalhoRow);
    };

    this.validaFornecedorBloqTpOperac = function(tipoOperacao, nrinsjurforn) {
        return Dfe11000_LancamentoEntrada_Repositories.buscaFornecedorBloqTpOperac(tipoOperacao, nrinsjurforn);
    };

    this.geraSenhaLancRetroativo = function(lancRetroativoRow){
        return Dfe11000_LancamentoEntrada_Repositories.geraSenhaLancRetroativo(lancRetroativoRow);
    };
    
    this.tipoEdicao = function(row){
        let filter = [];
        return General.callRestEngine("df#/crud/paramestoque", "FilterData", filter).then((response) => {
            return 'N';
/*            let permiteAlteracao = response.dataset.paramestoque[0].IDLANCDTMEN,
            difDiasAntPermitidos = parseInt(response.dataset.paramestoque[0].NRDIASENTR),
            dtLancto             = row.DTENTRSAID,
            dtProcessamento      = row.DTPROCESSA,
            difDias              = dtProcessamento.diff(dtLancto, 'days');
            
            if(permiteAlteracao == 'S'){
                if(difDiasAntPermitidos === null || difDiasAntPermitidos === undefined || difDias > difDiasAntPermitidos){
                    return 'S'; //Edição com senha
                } else{
                    return 'N'; //Edição normal
                }
            } else{
                return 'B'; //Edição bloqueada
            }*/
        });
    };

    this.salvaImpostosNotaFiscal = function(impostos) {

        var impostosTemp = [];
        var trabEntity = {
            "CDFILIMPTOT"  : "CDFILIAL",
            "NRLANCIMPTOT" : "NRLANCTONF",
            "CDIMPOSTOT"   : "CDIMPOSTO",
            "VRIMPOSTOT"   : "VRIMPOSTONF"
        };

        var columns = Object.keys(trabEntity);

        impostosTemp = Util.clone(impostos);

        impostosTemp.forEach(function(imposto) {
            columns.forEach(function(column) {
                if (!(column in imposto)) {
                    imposto[column] = imposto[trabEntity[column]];
                    delete imposto[trabEntity[column]];
                }
            });
            imposto.__is_new = true;
            imposto.VRBCALIMPTOT = 0;
        });
        
        return Dfe11000_LancamentoEntrada_Repositories.salvaImpostosNotaFiscal(impostosTemp);
    };

    this.validaInscEstadual = function(row){
        return General.callRestEngine("df_entrada#/validaInscEstadual", "Row", row);
    };
    
    this.limpaTrabsLancamento = function(cdfilial, nrlantonf) {
        return Dfe11000_LancamentoEntrada_Repositories.limpaTrabsLancamento(cdfilial, nrlantonf);
    };

    var converteDataParaComparacao = function(data) {
        return moment(data, 'DD/MM/YYYY').format('MM-DD-YYYY');
    };

    this.validaDataVencimento = function(dataEmissao, dataVencimento) {
        dataEmissao = converteDataParaComparacao(dataEmissao);
        dataVencimento = converteDataParaComparacao(dataVencimento);

        if (moment(dataVencimento).isBefore(dataEmissao) && !moment(dataEmissao).isSame(dataVencimento))
            return "Data de Vencimento deve ser maior ou igual a data de emissão";
    };

    this.validacaoSalvaCabecalhoEntrada = function(cabecalhoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.validacaoSalvaCabecalhoEntrada(cabecalhoRow);
    };

    this.buscaChaveAcesso = function(nracessonfe) {
        return Dfe11000_LancamentoEntrada_Repositories.buscaNfChaveAcesso(nracessonfe);
    };
    
    this.buscaChaveAcessoPorCampos = function(params){
        return Dfe11000_LancamentoEntrada_Repositories.buscaNfChaveAcessoPorCampos(params);
    };
    
    this.getFilial = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return General.callRestEngine("df#/crud/filial", "FilterData", filter);
    };

    this.realizaImportacaoChaveAcesso = function(cabecalhoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.realizaImportacaoChaveAcesso(cabecalhoRow);
    };

    var verificaLançamentoComImportacao = function(cabecalhoRow) {
        const ACCESS_KEY = !!cabecalhoRow.NRACESSONFE && (cabecalhoRow.IDPELANIMPXML != 'S' || !cabecalhoRow.MANUAL_POSTING);

        return {
            chaveAcesso: ACCESS_KEY,
            af: 'AF' in cabecalhoRow,
            todos: 'AF' in cabecalhoRow && ACCESS_KEY
        };
    };

    this.realizaImportacaoAfChaveAcesso = function(cabecalhoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.realizaImportacaoAfChaveAcesso(cabecalhoRow);
    };

    this.realizaImportacoes = function(cabecalhoRow) {
        var lancamentoComImportacao = verificaLançamentoComImportacao(cabecalhoRow);
        if(!!cabecalhoRow.__is_new) {
            if(lancamentoComImportacao.todos)
                return this.realizaImportacaoAfChaveAcesso(cabecalhoRow);
            else if(lancamentoComImportacao.af)
                return this.realizaImportacaoAf(cabecalhoRow);
            else if(lancamentoComImportacao.chaveAcesso)
                return this.realizaImportacaoChaveAcesso(cabecalhoRow);
        }
    };

    this.salvaRelacionamentoItensXml = function(relacionamentoRow) {
        return Dfe11000_LancamentoEntrada_Repositories.salvaRelacionamentoItensXml(relacionamentoRow);
    };

    this.removerRelacionamentoItemXml = function(cdprodutoxml, cdforneced,cdfilial, cdproduto) {
          return Dfe11000_LancamentoEntrada_Repositories.removerRelacionamentoItemXml(cdprodutoxml, cdforneced,cdfilial, cdproduto);
    };

    this.salvaMultiItens = function(novosItens, itensAlterados, currentRowParentWidget) {
        return Dfe11000_LancamentoEntrada_Repositories.salvaMultiItens(novosItens, itensAlterados, currentRowParentWidget);
    };
    
    this.atualizaItemAf = function(item) {
        return General.callRestEngine("df_entrada#/atualizaItemAf", "Row", item);
    };
    
    this.excluirItemAf = function(item) {
        return General.callRestEngine("df_entrada#/excluirItemAf", "Row", item);
    };
    
    this.setFornImportRastXml = function(IDIMPRASTXML) {
        let row = {IDIMPRASTXML};
        return localStorageEngine.setDataSource("df_entrada#/fornImportRastXml", row);
    };
    
    this.getFornImportRastXml = function() {
        return localStorageEngine.getDataSource("df_entrada#/fornImportRastXml").then((success) => {
            return success[0];
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe11000_LancamentoEntrada_Service", Dfe11000_LancamentoEntrada_Service);
});